## mshr 2019.2.0~git20230811.ff54a68+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,7 +14,7 @@
 # CGAL setup
 option(USE_SYSTEM_CGAL "Do not build CGAL, but use an existing build instead." OFF)
 if (USE_SYSTEM_CGAL)
-  find_package(CGAL 4.12 CONFIG REQUIRED)
+  find_package(CGAL 5 CONFIG REQUIRED)
 endif()
 
 # Borrow some cmake modules from cgal
@@ -43,8 +43,8 @@
   ENDFOREACH (value2)
 ENDMACRO(LIST_CONTAINS)
 
-# Use C++11
-SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x -Wall")
+# Use C++14 to support std:enable_if used by CGAL 5
+set(CMAKE_CXX_STANDARD 14)
 
 # Boost
 # This is workaround to avoid that find_package(Boost)
@@ -158,6 +158,9 @@
   ${Boost_MSHR_LIBRARIES}
   )
 
+# CMAKE_CXX_STANDARD is ignored ;( Need to set standard manually here.
+set_property(TARGET mshr PROPERTY CXX_STANDARD 14)
+
 # install library
 install(TARGETS mshr
   RUNTIME DESTINATION ${INSTALL_BIN_DIR}
@@ -174,6 +177,9 @@
     dolfin
     ${Boost_MSHR_LIBRARIES}
     )
+
+# CMAKE_CXX_STANDARD is ignored ;( Need to set standard manually here.
+set_property(TARGET mshrable PROPERTY CXX_STANDARD 14)
 
   # install app
   install(TARGETS mshrable
