=== debian/changelog ===
mshr (2019.2.0~git20230811.ff54a68+dfsg1-7) unstable; urgency=medium

  * update Build-Depends: libtet-dev for tetgen 1.6
  * debian patch CGAL_6.1_compatibility.diff enables build with CGAL 6.1

 -- Drew Parsons <dparsons@debian.org>  Sun, 05 Oct 2025 22:04:07 +0200

mshr (2019.2.0~git20230811.ff54a68+dfsg1-6) unstable; urgency=medium

  * Add boost_filesystem_extension.patch:
    - Closes: #1110752.
    - Patches app/mshrable.cpp by accessing file extension via
      boost::filesystem.
    - Thanks to Heinrich Schuchardt <heinrich.schuchardt@canonical.com> for
      providing the patch.

 -- Francesco Ballarin <ballarin@debian.org>  Sat, 04 Oct 2025 13:27:06 +0000

mshr (2019.2.0~git20230811.ff54a68+dfsg1-5) unstable; urgency=medium

  * Fix Debian Science Maintainers name [Alexandre Detiste]
  * Update Francesco Ballarin's email address
  * Standards-Version: 4.7.2 (routine-update)
  * Reorder sequence of d/control fields by cme (routine-update)
  * Secure URI in copyright format (routine-update)
  * Drop useless get-orig-source target (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Do not parse d/changelog, as suggested by routine-update:
    - Get DEB_VERSION from /usr/share/dpkg/default.mk in d/rules
    - Drop usage of DISTRIBUTION from d/rules: it seems that the variable is not
      actually used anywhere
  * Use secure URI in Homepage field (routine-update)
  * Add missing build dependency on python3-numpy-dev for command dh_numpy3
    (routine-update).
  * watch file standard 4 (routine-update)

 -- Francesco Ballarin <ballarin@debian.org>  Sat, 13 Sep 2025 06:12:51 +0000

mshr (2019.2.0~git20230811.ff54a68+dfsg1-4) unstable; urgency=medium

  * Bump Standards-Version to 4.7.0
  * Force rebuild against OpenMPI 5. Closes: #1086299.

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sun, 03 Nov 2024 14:45:53 +0000

mshr (2019.2.0~git20230811.ff54a68+dfsg1-3) unstable; urgency=medium

  * Upload to unstable

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sun, 06 Oct 2024 13:52:13 +0000

mshr (2019.2.0~git20230811.ff54a68+dfsg1-2exp1) experimental; urgency=medium

  * Add Francesco Ballarin to uploaders
  * Add patch CGAL_6_compatibility.diff for compatibility with CGAL 6:
    - bump minum required CGAL version to 6 in cmake
    - require C++17 standard in cmake
    - replace boost::get and assignment to a local variable with CGAL::assign
    Closes: #1074116
  * Build-Depends on libcgal-dev >= 6.0~

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Tue, 25 Jun 2024 12:40:24 +0000

mshr (2019.2.0~git20230811.ff54a68+dfsg1-1) unstable; urgency=medium

  [ Bas Couwenberg ]
  * Drop unused libproj-dev (build) dependency.

  [ Drew Parsons ]
  * New upstream snapshot.
    - applies debian patches:
      fix_mesh3_internal.patch
      enable_CGAL5_CXX14.patch
      build_CGAL5.patch
      build_CGAL5.6.patch

 -- Drew Parsons <dparsons@debian.org>  Mon, 05 Feb 2024 20:10:04 +0100

mshr (2019.2.0~git20200924.c27eb18+dfsg1-10) unstable; urgency=medium

  * update debian patch build_CGAL5.6.patch for backwards compatibility
    - apply named parameters one-by-one
    - check CGAL version when calling has_Has_features

 -- Drew Parsons <dparsons@debian.org>  Thu, 10 Aug 2023 16:23:24 +0200

mshr (2019.2.0~git20200924.c27eb18+dfsg1-9) unstable; urgency=medium

  * make mshr.pth more robust with respect to PETSc installation.
    Use default path if petscconf.h can't be found. Closes: #1000950.
  * debian patch build_CGAL5.6.patch fixes build for CGAL 5.6.
    Named parameters can only be set in CGAL functions.
    Closes: #1043307
  * Standards-Version: 4.6.2

 -- Drew Parsons <dparsons@debian.org>  Thu, 10 Aug 2023 03:47:17 +0200

mshr (2019.2.0~git20200924.c27eb18+dfsg1-8) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on cmake, libcgal-dev and
      python3-pybind11.
    + libmshr-dev-common: Drop versioned constraint on cmake in Depends.

 -- Drew Parsons <dparsons@debian.org>  Sat, 22 Jul 2023 15:18:42 +0200
