=== debian/tests/control ===
Tests: test-mshr-python
Depends: python3-mshr,
	  python3-pytest

Tests: test-mshr64-python,
Depends: python3-mshr64-real,
	  python3-mshr,
	  python3-pytest
