=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg1 \
https://bitbucket.org/fenics-project/mshr/downloads/mshr-(.*)\.tar\.gz
